/****************************************************************************/
/*! @file
@brief DirectShow media sample wrapper for Windows media format

DirectShowMedia SamplebvWindows Media Format SDKpBuffer
-----------------------------------------------------------------------------
	Copyright (C) 2005 T.Imoto <http://www.kaede-software.com>
-----------------------------------------------------------------------------
@author		T.Imoto
@date		2005/10/28
@note
*****************************************************************************/

#include "CWMBuffer.h"

//----------------------------------------------------------------------------
//! @brief	  	vꂽC^[tFCXԂ
//! @param		riid : C^[tFCXIID
//! @param		ppv : C^[tFCXԂ|C^[ւ̃|C^
//! @return		G[R[h
//----------------------------------------------------------------------------
STDMETHODIMP CWMBuffer::NonDelegatingQueryInterface( REFIID riid, void ** ppv )
{
	if( IID_INSSBuffer == riid ) {
		return GetInterface(static_cast<INSSBuffer*>(this), ppv);
	} else if( riid == IID_IMediaSample ) {
		return GetInterface(static_cast<IMediaSample*>(m_Sample), ppv);
	} else {
		return CUnknown::NonDelegatingQueryInterface(riid, ppv);
	}
}
//----------------------------------------------------------------------------
//! @brief	  	obt@擾
//! @param		ppdwBuffer : |C^̃|C^
//! @return		G[R[h
//----------------------------------------------------------------------------
STDMETHODIMP CWMBuffer::GetBuffer( BYTE **ppdwBuffer )
{
	return Sample()->GetPointer( ppdwBuffer );
}
//----------------------------------------------------------------------------
//! @brief	  	obt@ƃTCY擾
//! @param		ppdwBuffer : |C^̃|C^
//! @param		pdwLength : TCY
//! @return		G[R[h
//----------------------------------------------------------------------------
STDMETHODIMP CWMBuffer::GetBufferAndLength( BYTE **ppdwBuffer, DWORD *pdwLength )
{
	*pdwLength = static_cast<DWORD>( Sample()->GetActualDataLength() );
	return Sample()->GetPointer( ppdwBuffer );
}
//----------------------------------------------------------------------------
//! @brief	  	f[^i[ĂTCY擾
//! @param		pdwLength : TCY
//! @return		G[R[h
//----------------------------------------------------------------------------
STDMETHODIMP CWMBuffer::GetLength( DWORD *pdwLength )
{
	*pdwLength = static_cast<DWORD>( Sample()->GetActualDataLength() );
	return S_OK;
}
//----------------------------------------------------------------------------
//! @brief	  	obt@̃TCY擾
//! @param		pdwLength : TCY
//! @return		G[R[h
//----------------------------------------------------------------------------
STDMETHODIMP CWMBuffer::GetMaxLength( DWORD *pdwLength )
{
	*pdwLength = static_cast<DWORD>( Sample()->GetSize() );
	return S_OK;
}
//----------------------------------------------------------------------------
//! @brief	  	TCYݒ肷
//! @param		dwLength : TCY
//! @return		G[R[h
//----------------------------------------------------------------------------
STDMETHODIMP CWMBuffer::SetLength( DWORD dwLength )
{
	return Sample()->SetActualDataLength( static_cast<long>( dwLength ) );
}

